<?php
require_once 'functions.php';

$liveCodes = getLiveCodes();
$name = isset($_GET['name']) ? trim($_GET['name']) : '';

// 如果没有指定名称，显示所有活码
if (empty($name)) {
    header('Content-Type: text/html; charset=utf-8');
    ?>
    <!DOCTYPE html>
    <html>
    <head>
        <title>活码系统</title>
        <style>
            body { font-family: Arial, sans-serif; max-width: 800px; margin: 0 auto; padding: 20px; }
            h1 { text-align: center; }
            ul { list-style: none; padding: 0; }
            li { margin: 10px 0; }
            a { display: block; padding: 10px; background: #f5f5f5; text-decoration: none; color: #333; }
            a:hover { background: #e5e5e5; }
            .admin-link { text-align: center; margin-top: 30px; }
        </style>
    </head>
    <body>
        <h1>可用活码列表</h1>
        <ul>
            <?php foreach ($liveCodes as $codeName => $code): ?>
                <li><a href="?name=<?php echo urlencode($codeName); ?>"><?php echo htmlspecialchars($codeName); ?></a></li>
            <?php endforeach; ?>
        </ul>
        <div class="admin-link">
            <a href="admin.php">管理活码</a>
        </div>
    </body>
    </html>
    <?php
    exit;
}

// 显示指定的活码
if (isset($liveCodes[$name])) {
    $file = $liveCodes[$name]['path'];
    $mime = mime_content_type($file);
    
    header('Content-Type: ' . $mime);
    header('Content-Length: ' . filesize($file));
    readfile($file);
    exit;
} else {
    header('HTTP/1.0 404 Not Found');
    header('Content-Type: text/html; charset=utf-8');
    ?>
    <!DOCTYPE html>
    <html>
    <head>
        <title>活码不存在</title>
    </head>
    <body>
        <h1>活码不存在</h1>
        <p><a href="index.php">返回列表</a></p>
    </body>
    </html>
    <?php
    exit;
}