<?php
// 设置编码
header('Content-Type: text/html; charset=utf-8');

// 检查登录状态
session_start();
if (!isset($_SESSION['logged_in'])) {
    header('Location: admin.php');
    exit;
}

// 定义上传目录
define('UPLOAD_DIR', 'uploads/');

// 处理替换请求
if ($_SERVER['REQUEST_METHOD'] === 'GET' && isset($_GET['name'])) {
    $name = $_GET['name'];
    $existing_file = UPLOAD_DIR . $name . '.*';
    $files = glob($existing_file);
    
    if (empty($files)) {
        die('活码不存在');
    }
    
    show_replace_form($name, $files[0]);
} elseif ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_FILES['image'])) {
    $name = trim($_POST['name']);
    $file = $_FILES['image'];
    
    // 验证名称
    if (empty($name)) {
        die('活码名称不能为空');
    }
    
    // 验证文件
    if ($file['error'] !== UPLOAD_ERR_OK) {
        die('上传失败，错误代码: ' . $file['error']);
    }
    
    // 检查文件类型
    $allowed_types = ['image/jpeg', 'image/png', 'image/gif', 'image/webp'];
    if (!in_array($file['type'], $allowed_types)) {
        die('只允许上传JPEG, PNG, GIF或WEBP格式的图片');
    }
    
    // 检查文件大小 (限制为5MB)
    if ($file['size'] > 5 * 1024 * 1024) {
        die('图片大小不能超过5MB');
    }
    
    // 查找旧文件
    $old_file = UPLOAD_DIR . $name . '.*';
    $old_files = glob($old_file);
    
    if (empty($old_files)) {
        die('活码不存在');
    }
    
    // 生成新文件名
    $extension = pathinfo($file['name'], PATHINFO_EXTENSION);
    $new_filename = $name . '.' . $extension;
    $target_path = UPLOAD_DIR . $new_filename;
    
    // 删除旧文件
    foreach ($old_files as $old) {
        unlink($old);
    }
    
    // 移动新文件
    if (move_uploaded_file($file['tmp_name'], $target_path)) {
        // 设置权限
        chmod($target_path, 0644);
        header('Location: admin.php');
        exit;
    } else {
        die('文件移动失败，请检查目录权限');
    }
} else {
    header('Location: admin.php');
    exit;
}

function show_replace_form($name, $current_file) {
    echo <<<HTML
<!DOCTYPE html>
<html lang="zh-CN">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>替换活码</title>
    <style>
        body { font-family: Arial, sans-serif; max-width: 500px; margin: 50px auto; padding: 20px; }
        .replace-form { border: 1px solid #ddd; padding: 20px; border-radius: 5px; }
        .form-group { margin-bottom: 15px; }
        label { display: block; margin-bottom: 5px; }
        input[type="file"] { width: 100%; padding: 8px; box-sizing: border-box; }
        button { background: #4CAF50; color: white; border: none; padding: 10px 15px; cursor: pointer; }
        .current-image { max-width: 200px; display: block; margin: 10px 0; }
    </style>
</head>
<body>
    <div class="replace-form">
        <h2>替换活码: {$name}</h2>
        <p>当前图片:</p>
        <img src="../index.php?name={$name}" class="current-image">
        
        <form method="post" enctype="multipart/form-data">
            <input type="hidden" name="name" value="{$name}">
            <div class="form-group">
                <label for="image">选择新图片</label>
                <input type="file" id="image" name="image" accept="image/*" required>
            </div>
            <button type="submit">替换</button>
            <a href="admin.php" style="margin-left: 10px;">取消</a>
        </form>
    </div>
</body>
</html>
HTML;
}
?>