<?php
// 设置编码
header('Content-Type: text/html; charset=utf-8');

// 检查登录状态
session_start();
if (!isset($_SESSION['logged_in'])) {
    header('Location: admin.php');
    exit;
}

// 定义上传目录
define('UPLOAD_DIR', 'uploads/');

// 确保上传目录存在
if (!file_exists(UPLOAD_DIR)) {
    mkdir(UPLOAD_DIR, 0777, true);
}

// 处理上传
if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_FILES['image'])) {
    $name = trim($_POST['name']);
    $file = $_FILES['image'];
    
    // 验证名称
    if (empty($name)) {
        die('活码名称不能为空');
    }
    
    // 验证文件
    if ($file['error'] !== UPLOAD_ERR_OK) {
        die('上传失败，错误代码: ' . $file['error']);
    }
    
    // 检查文件类型
    $allowed_types = ['image/jpeg', 'image/png', 'image/gif', 'image/webp'];
    if (!in_array($file['type'], $allowed_types)) {
        die('只允许上传JPEG, PNG, GIF或WEBP格式的图片');
    }
    
    // 检查文件大小 (限制为5MB)
    if ($file['size'] > 5 * 1024 * 1024) {
        die('图片大小不能超过5MB');
    }
    
    // 生成安全文件名
    $extension = pathinfo($file['name'], PATHINFO_EXTENSION);
    $filename = preg_replace('/[^a-zA-Z0-9_\x{4e00}-\x{9fa5}]/u', '', $name) . '.' . $extension;
    $target_path = UPLOAD_DIR . $filename;
    
    // 移动文件
    if (move_uploaded_file($file['tmp_name'], $target_path)) {
        // 设置权限
        chmod($target_path, 0644);
        header('Location: admin.php');
        exit;
    } else {
        die('文件移动失败，请检查目录权限');
    }
} else {
    header('Location: admin.php');
    exit;
}
?>